#include <bits/stdc++.h>
using namespace std;
const int N=3e5+6;
long long n,m,cnt,ans;
long long rec(long long x, long long y){
    if(x==1 && y==1){
        return 1;
    }
    else{
    	if(x!=1){
    		if(y<x){
	            swap(x,y);
	        }
	        if(x%2==0){
	            return rec(x/2,y)+rec(x/2,y)+x*y;
	        }
	        else{
	            return rec(x/2+1,y)+rec(x/2,y)+x*y;
	        }
		}
        else{
	        if(y%2==0){
	            return rec(x,y/2)+rec(x,y/2)+x*y;
	        }
	        else{
	            return rec(x,y/2+1)+rec(x,y/2)+x*y;
	        }
		}
    }
}
int main (){
    cin >> n >> m;
    cout << rec(n,m);
}
